unit slide_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, types, BGRABitmap, BGRABitmapTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    knop: TButton;
    procedure FormResize(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure knopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    image      : TBGRABitmap;
    image_from : TBGRABitmap;
    image_to   : TBGRABitmap;
    procedure resize_to_slide_show( work_image: TBGRABitmap; str_image : string );

  public

  end;

var
  Form1: TForm1;
  nfoto : integer;

implementation

{$R *.lfm}

{ TForm1 }


//-----------------------------------------------------

procedure TForm1.resize_to_slide_show( work_image: TBGRABitmap; str_image : string );
var
  FormVerhouding      : Single;
  BeeldVerhouding     : Single;
  SlideBreedte   : Integer;
  SlideHoogte  : Integer;
  RectSlide       : TRect;
  image_tmp       : TBGRABitmap;
begin

  try
    RectSlide       := TRect.Create(0,0,Form1.Width,Form1.Height);

//  load backgroundimage to fill whole projectioncanvas
    image_tmp := TBGRABitmap.Create( 'black.jpg' );

    work_image.StretchPutImage(RectSlide, image_tmp, dmset, 255);
    image_tmp.Free;

// get picture to be loaded
    image_tmp := TBGRABitmap.Create( str_image );

// scale en ratio
    FormVerhouding  := Form1.Width / Form1.Height;
    BeeldVerhouding := image_tmp.Width / image_tmp.Height;

    if FormVerhouding > BeeldVerhouding then // use same height
    begin
      SlideHoogte := Form1.Height;
      SlideBreedte  := Round(SlideHoogte * BeeldVerhouding);
    end
    else begin                        // use same width
      SlideBreedte  := Form1.Width;
      SlideHoogte := Round(SlideBreedte / BeeldVerhouding);
    end;
    if (image_tmp.Width < form1.Width) or
       (image_tmp.Height < form1.Height) then
    begin
      image_tmp.ResampleFilter := rfBestQuality;
      BGRAReplace(image_tmp, image_tmp.Resample(form1.Width, form1.Height));
    end;

// center SLide
    RectSlide.Left   := (Form1.Width  - SlideBreedte)  div 2;
    RectSlide.Top    := (Form1.Height - SlideHoogte) div 2;
    RectSlide.Width  := SlideBreedte;
    RectSlide.Height := SlideHoogte;

    work_image.StretchPutImage(RectSlide, image_tmp, dmSet, 255);

  finally
    image_tmp.Free;
  end;
end;

//------------------------------------------------------

procedure TForm1.knopClick(Sender: TObject);
var
  nknop : integer;
  str_foto_from, str_foto_to : string;
begin
  Knop.Visible := false;
  if nfoto = 0 then
  begin
    str_foto_from := 'black.jpg';
    str_foto_to   := 'img_044000d.jpg';
  end;
  if nfoto = 1 then
  begin
    str_foto_from := 'img_044000d.jpg';
    str_foto_to   := 'img_045014d.jpg';
  end;
  if nfoto = 2 then
  begin
    str_foto_from := 'img_045014d.jpg';
    str_foto_to   := 'img_044333d.jpg';
  end;
  if nfoto = 3 then
  begin
    str_foto_from := 'img_044333d.jpg';
    str_foto_to   := 'img_042000d.jpg';
  end;
  if nfoto = 4 then
  begin
    str_foto_from := 'img_042000d.jpg';
    str_foto_to   := 'black.jpg';
  end;

  nfoto := nfoto + 1;
  if nfoto = 5 then nfoto := 0;

  resize_to_slide_show( image_from, str_foto_from );
  resize_to_slide_show( image_to, str_foto_to );

  for nknop := 1 to 51 do
  begin
    knop.Tag := nknop;
    form1.Tag := 1;
    form1.Repaint;
  end;
  Knop.Visible := true;
end;


procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
    image.SetSize(ClientWidth,ClientHeight);
  image.Fill(BGRAWhite);

end;

procedure TForm1.FormResize(Sender: TObject);
begin
  image_from.SetSize(ClientWidth,ClientHeight);
  image_to.SetSize(ClientWidth,ClientHeight);
  image.SetSize(ClientWidth,ClientHeight);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  image_from := TBGRABitmap.Create(ClientWidth,ClientHeight);
  image_to   := TBGRABitmap.Create(ClientWidth,ClientHeight);
  image      := TBGRABitmap.Create(ClientWidth,ClientHeight);
//  image.SetSize(ClientWidth,ClientHeight);
  image.Fill(BGRABlack);
  nfoto := 0;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  destRect: TRect;
begin
  if form1.Tag = 1 then
  begin
    OffsetRect(destRect, (image.width - destRect.width) div 2, (image.height - destRect.height) div 2);
    image.CrossFade(Rect(0,0,image.Width, image.Height), image_from, image_to, round(knop.tag * 5), dmSet);
    sleep( 20 );
    image.Draw(Canvas, 0,0);
    Form1.Tag := 2; // ready to next
  end;
end;

end.

